nx_metadata_sdk 1.0 Metadata SDK

Public Types | Public Member Functions | Protected Member Functions | List of all members
nx::sdk::analytics::Plugin Class Reference

`#include <plugin.h>`

Inheritance diagram for nx::sdk::analytics::Plugin:

## Public Types
using | CreateEngine = std::function< IEngine *(Plugin *plugin)>
Public Types inherited from nx::sdk::IPlugin
typedef IPlugin *(* | EntryPointFunc) ()

## Public Member Functions
| Plugin (std::string pluginManifest, CreateEngine createEngine)
Ptr< IUtilityProvider > | utilityProvider () const
virtual void | setUtilityProvider (IUtilityProvider *utilityProvider) override
Public Member Functions inherited from nx::sdk::RefCountable< IPlugin >
| RefCountable (const RefCountable &)=delete
| RefCountable (RefCountable &&)=delete
RefCountable & | operator= (const RefCountable &)=delete
RefCountable & | operator= (RefCountable &&)=delete
virtual int | addRef () const override
virtual int | releaseRef () const override
int | refCount () const
Public Member Functions inherited from nx::sdk::Interface< IPlugin >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IRefCountable
virtual | ~IRefCountable ()=default
template<class Interface >
Ptr< Interface > | queryInterface ()
template<class Interface >
Ptr< const Interface > | queryInterface () const
int | refCountThreadUnsafe () const

## Protected Member Functions
virtual void | getManifest (Result< const IString *> *outResult) const override
virtual void | doCreateEngine (Result< IEngine *> *outResult) override
Protected Member Functions inherited from nx::sdk::Interface< IPlugin >
virtual IRefCountable * | queryInterface (const IRefCountable::InterfaceId *id) override
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)

## Additional Inherited Members
Static Public Member Functions inherited from nx::sdk::IPlugin
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IRefCountable
static auto | interfaceId ()
Static Public Attributes inherited from nx::sdk::IPlugin
static constexpr const char * | kEntryPointFuncName = "createNxPlugin"
Static Protected Member Functions inherited from nx::sdk::IRefCountable
template<int len>
static constexpr const InterfaceId * | makeId (const char(&charArray)[len])
template<class TemplateInstance , class TemplateArg , int len>
static const InterfaceId * | makeIdForTemplate (const char(&baseIdCharArray)[len])

## Detailed Description

Base class for a typical implementation of an Analytics Plugin. Hides many technical details of the Analytics Plugin SDK, but may limit plugin capabilities - use only when suitable.

## Constructor & Destructor Documentation

## ◆ Plugin()

nx::sdk::analytics::Plugin::Plugin | ( | std::string | pluginManifest,
|  | CreateEngine | createEngine
| ) |  |

Parameters

  pluginManifest | Plugin manifest to be returned from the manifest method.
  createEngine | Functor for engine creation.

## Member Function Documentation

## ◆ setUtilityProvider()

void nx::sdk::analytics::Plugin::setUtilityProvider | ( | IUtilityProvider * | utilityProvider | ) |
| override virtual

Provides an object which the plugin can use for calling back to access some data and functionality provided by the process that uses the plugin.

For details, see the documentation for IUtilityProvider.

Implements nx::sdk::IPlugin.

The documentation for this class was generated from the following files:

- src/nx/sdk/analytics/helpers/plugin.h
- src/nx/sdk/analytics/helpers/plugin.cpp